
/* *********************************************************************** */
/* AutelService*/
/* *********************************************************************** */

use [oktell]
GO

IF  EXISTS (SELECT * FROM sys.server_principals WHERE name = N'AutelService')
DROP LOGIN [AutelService]
GO

sp_addlogin 'AutelService', 'Version2', 'oktell'
GO

sp_addsrvrolemember N'AutelService', sysadmin
GO

sp_addrolemember 'db_owner','AutelService'
GO

EXEC master.dbo.sp_defaultlanguage @loginame = N'AutelService', @language = N'us_english'

GO




/* *********************************************************************** */
/*     -*/
/* *********************************************************************** */
use [oktell]
GO

if not ( object_id ( 'dbo.WO_Database_ModuleRefreshUsers' ) is NULL )
     Drop procedure dbo.WO_Database_ModuleRefreshUsers
GO

CREATE procedure dbo.WO_Database_ModuleRefreshUsers
as
begin

     Declare @moduleid nvarchar(200), @moduledbname nvarchar(200), @moduledbuser nvarchar(500), @moduledbpass nvarchar(500)
     Declare @s_moduledbname nvarchar(500)
     Declare @oktelldb nvarchar(200), @oktellccdb nvarchar(200), @oktellsettingsdb nvarchar(200)
     Select @oktelldb = 'Oktell', @oktellccdb = 'oktell_cc_temp', @oktellsettingsdb = 'oktell_settings'
     
     Declare CUR Cursor For
          Select code, dbname, dbname, dbuserlogin, dbuserpass
          FROM WO_InstalledModules
          Where not dbname is null and dbname != ''			
     
     Open CUR
     Fetch Next From CUR Into @moduleid, @moduledbname, @s_moduledbname, @moduledbuser, @moduledbpass
     
     While (@@fetch_Status = 0) begin
     
          Print @moduledbname
          
          
          Declare @Statement nvarchar(4000),
                    @pre_Statement nvarchar(4000)
         
          Declare @db_path varchar (4000)
         
          Declare @collate_oktell  varchar (500)
         
        SET @collate_oktell = cast(DATABASEPROPERTYEX(@oktelldb, 'Collation') as VARCHAR(500))

          IF (SELECT cast(replace(left(cast(SERVERPROPERTY('productversion') as VARCHAR),2),'.','') as INT)  ) > 8
          BEGIN
               SELECT @db_path = physical_name FROM sys.master_files WHERE database_id = DB_ID(N'master') AND type_desc = 'ROWS'
          END ELSE BEGIN
               SELECT @db_path = rtrim(ltrim([filename])) FROM [master]..sysfiles WHERE [name] = 'master' 
          END
         
          SET @db_path = REVERSE(RIGHT(REVERSE(@db_path),(LEN(@db_path)-CHARINDEX('\', REVERSE(@db_path),1))+1))
		  		  
          /* DB & login creation */
          Set @Statement = N'
               /* DB master */
               USE [master]
               
               /* Here was db creation */

               If not exists (Select * From syslogins Where [name] = ''' + @moduledbuser + ''') begin
					USE [' + @s_moduledbname + ']
					IF NOT SCHEMA_ID(''' + @moduledbuser + ''') IS NULL
						DROP SCHEMA [' + @moduledbuser + ']
					IF EXISTS (SELECT * FROM sys.database_principals WHERE name = ''' + @moduledbuser + ''')
					DROP USER [' + @moduledbuser + ']

					USE [' + @oktelldb + ']
					IF NOT SCHEMA_ID(''' + @moduledbuser + ''') IS NULL
						DROP SCHEMA [' + @moduledbuser + ']
					IF EXISTS (SELECT * FROM sys.database_principals WHERE name = ''' + @moduledbuser + ''')
					DROP USER [' + @moduledbuser + ']

					USE [' + @oktellccdb + ']
					IF NOT SCHEMA_ID(''' + @moduledbuser + ''') IS NULL
						DROP SCHEMA [' + @moduledbuser + ']
					IF EXISTS (SELECT * FROM sys.database_principals WHERE name = ''' + @moduledbuser + ''')
					DROP USER [' + @moduledbuser + ']

					USE [' + @oktellsettingsdb + ']
					IF NOT SCHEMA_ID(''' + @moduledbuser + ''') IS NULL
						DROP SCHEMA [' + @moduledbuser + ']
					IF EXISTS (SELECT * FROM sys.database_principals WHERE name = ''' + @moduledbuser + ''')
					DROP USER [' + @moduledbuser + ']
               
					USE [master]
                    Exec sp_addlogin 
                         @loginame=''' + @moduledbuser + ''',
                         @passwd=''' + @moduledbpass + ''',
                         @defdb=''' + @s_moduledbname + '''
				end
          '
          
          Exec sp_executesql @Statement
         
         
          /* DBs access */
          Set @pre_Statement = N'
                    If not exists (Select 1 From sysusers Where name = ''db_select_and_executor'') begin
                         Exec sp_addrole ''db_select_and_executor''
                    end
              
                    Exec sp_addrolemember ''db_datareader'', ''db_select_and_executor'' 
                    ' + 
           CASE WHEN cast(replace(left(cast(SERVERPROPERTY('productversion') as VARCHAR),2),'.','') as INT)  > 8 
           THEN N' GRANT EXEC TO db_select_and_executor '
           ELSE N'
                    SET @sql1 = ''''
                   
                    Declare curs Cursor For
                         Select [name] 
                         From sysobjects 
                         Where xtype in (''P'', ''FN'')

                    Open curs

                    Fetch Next From curs Into @sql1
                   
                    While (@@FETCH_STATUS = 0) begin
                    
                         Set @sql1 = ''GRANT EXEC ON ''  + @sql1 +  '' TO db_select_and_executor ''
                         Exec sp_executesql @sql1
                         Fetch Next From curs Into @sql1
                         
                    end
              
                    Close curs
                    Deallocate curs
               '
          END + N'
                    If not exists (Select * From sysusers Where ([name] = ''' + @moduledbuser + ''') and (issqluser = 1))
                         Exec sp_adduser 
                              @loginame=''' + @moduledbuser + ''', 
                              @name_in_db=''' + @moduledbuser + ''' , 
                              @grpname = ''db_select_and_executor'' 
          '
         
          Set @Statement = N'
               /* User to access DBs */
               Use [' + @moduledbname + ']
               
               If not exists (Select * From sysusers Where ([name] = ''' + @moduledbuser + ''') and (issqluser = 1))
                    Exec sp_adduser 
                         @loginame=''' + @moduledbuser + ''', 
                         @name_in_db=''' + @moduledbuser + ''' , 
                         @grpname = ''db_owner''  
         
               Declare @sql1 nvarchar(4000)
         
               USE [' + @oktelldb + ']
               ' + @pre_Statement + '
               
               USE [' + @oktellccdb + ']
               ' + @pre_Statement + '
               
               USE [' + @oktellsettingsdb + ']
               ' + @pre_Statement

          Exec sp_executesql @Statement
          
          
          Fetch Next From CUR Into @moduleid, @moduledbname, @s_moduledbname, @moduledbuser, @moduledbpass
          
     end
     
     Close CUR
     Deallocate CUR
  
end
GO

/* *********************************************************************** */
/*   */
/* *********************************************************************** */

exec WO_Database_ModuleRefreshUsers
GO



/* *********************************************************************** */
/*  AutelService */
/* *********************************************************************** */


USE oktell
GO
EXEC sys.sp_changedbowner 'AutelService'

USE oktell_settings
GO
EXEC sys.sp_changedbowner 'AutelService'
ALTER DATABASE [oktell] SET TRUSTWORTHY ON;
ALTER DATABASE [oktell_settings] SET TRUSTWORTHY ON;
GO